# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc返利规则编辑功能验证,2271,2271-14,sit,bs
主数据平台:后台运营系统返利规则详情获取接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload23_list")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取指定返利规则信息
rebate_id = result["data"]["list"][0]["rebateid"]

# 第二步获取返利规则详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url23")
request_body = commonFuc().get_business_data(module, "payload23", rebate_id)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# 获取返利规则信息
customer_code = result["data"]["customerDataList"][0]["customercode"]
customer_name = result["data"]["customerDataList"][0]["customername"]
product_code = result["data"]["productDataList"][0]["productcode"]
product_name = result["data"]["productDataList"][0]["productname"]
specifications = result["data"]["productDataList"][0]["specifications"]
manufacturer = result["data"]["productDataList"][0]["manufacturer"]

# 第三步进行返利规则更新操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url24")
request_body = commonFuc().get_business_data(module, "payload24", customer_name, customer_code, product_code,
                                             product_name, specifications, manufacturer, rebate_id)

"""
 场景: 返利规则编辑功能验证
 用例名称：返利规则编辑功能验证
 输出：{"success":true,"code":"200","message":"ok","data":true}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
result["api_time"] = api_time
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict24")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
