# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_客户范围,2271,2271-27,sit,bs
主数据平台:后台运营系统返利规则商品客户范围查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利规则
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)

# 获取返利规则信息
rebate_id = result["data"]["list"][rebate_random]["rebateid"]
print(rebate_id)
# 第三步获取返利规则对应的客户范围
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url13")
request_body = commonFuc().get_business_data(module, "payload13", rebate_id)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 生成一个随机数字，用于后续随机选择某一条客户信息
customer_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取返利规则中客户范围列表中某一条客户信息
customer_name = result["data"]["list"][customer_random]["customername"]
customer_code = result["data"]["list"][customer_random]["customercode"]

# 第四步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url14")
request_body = commonFuc().get_business_data(module, "payload14", customer_name, customer_code, rebate_id)
print(request_body)
"""

 场景: 验证返利规则对应的客户范围列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_客户范围
 输出：{"customercode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
# 获取查询结果对应的客户编号
result = {"customercode": result["data"]["list"][0]["customercode"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict14", customer_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
