# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc批量导入客户验证_返利发放管理,2271,2271-37,sit,bs
主数据平台:运营后台管理系统返利发放客户批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os
import random

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/批量导入用户模板.xlsx"

# 第二步获取三方用户信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字，用于后续随机选择三方用户信息
user_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取三方用户信息
customer_name = result["data"]["list"][user_random]["customerName"]
customer_code = result["data"]["list"][user_random]["customerCode"]
# customer_code = "1017911"
# 生成返利金额
amount = float(random.randint(1, 1000))
# 将客户信息写入导入模板中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=customer_code)
excel.write_data(row=2, column=2, value=customer_name)
excel.write_data(row=2, column=3, value=amount)
excel.write_data(row=2, column=4, value="批量导入客户验证")

# 第四步，进行文件导入操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
场景: 批量导入客户验证_返利发放管理
用例名称：批量导入客户验证_返利发放管理
输出：{"customerCode":"%s"}
"""
# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
file.close()
if result["success"]:
    # 导入成功
    result = {"customerCode": result["data"][0]["customerCode"]}
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict40", customer_code)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 客户编码未与此站点首营
    result = {"message": result["message"]}
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict40_1")
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
